/***************************************************************************
 *   Copyright (C) 2004 by Marek Sopko                                     *
 *   avatar@host.sk                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "OGL.h"

// konstruktor *************************************************************
COGL::COGL()
{

}

// destruktor **************************************************************
COGL::~COGL()
{

}

// inicializacia OpenGL - nastavenie parametrov pre tvorbu OpenGL sceny ****
bool COGL::gl_initialize(GLvoid)
{
 GLuint a,b;

 // definicia premennych ***************************************************
 for (a=0;a<8;a++) { // nastavenie 8 vseobecnych materialov
  ogl_material[a].amb[0]=0.2f; ogl_material[a].amb[1]=0.2f;
  ogl_material[a].amb[2]=0.2f; ogl_material[a].amb[3]=1.0f;
  ogl_material[a].dif[0]=0.8f; ogl_material[a].dif[1]=0.8f;
  ogl_material[a].dif[2]=0.8f; ogl_material[a].dif[3]=1.0f;
  ogl_material[a].spe[0]=0.0f; ogl_material[a].spe[1]=0.0f;
  ogl_material[a].spe[2]=0.0f; ogl_material[a].spe[3]=1.0f;
  ogl_material[a].amb_dif[0]=0.2f; ogl_material[a].amb_dif[1]=0.2f;
  ogl_material[a].amb_dif[2]=0.2f; ogl_material[a].amb_dif[3]=1.0f;
  ogl_material[a].emi[0]=0.0f; ogl_material[a].emi[1]=0.0f;
  ogl_material[a].emi[2]=0.0f; ogl_material[a].emi[3]=1.0f;
  ogl_material[a].shi=0.0f;
  ogl_material[a].transp=0.0f;
  ogl_material[a].sillum[0]=0.0f; ogl_material[a].sillum[1]=0.0f;
  ogl_material[a].sillum[2]=0.0f; ogl_material[a].sillum[3]=1.0f;
 }

 for (a=0;a<8;a++) { // nastavenie 8 vseobecnych svetiel
  ogl_light[a].amb[0]=0.5f; ogl_light[a].amb[1]=0.5f;
  ogl_light[a].amb[2]=0.5f; ogl_light[a].amb[3]=1.0f;
  ogl_light[a].dif[0]=0.75f; ogl_light[a].dif[1]=0.75f;
  ogl_light[a].dif[2]=0.75f; ogl_light[a].dif[3]=1.0f;
  ogl_light[a].spe[0]=1.0f; ogl_light[a].spe[1]=1.0f;
  ogl_light[a].spe[2]=1.0f; ogl_light[a].spe[3]=1.0f;
  ogl_light[a].pos[0]=0.0f; ogl_light[a].pos[1]=10.0f;
  ogl_light[a].pos[2]=0.0f; ogl_light[a].pos[3]=1.0f;
  ogl_light[a].spot[0]=0.0f;
  ogl_light[a].spot[1]=0.0f;
  ogl_light[a].spot[2]=-1.0f;
 }

 for (a=0;a<8;a++) { // nastavenie 8 vseobecnych kamier
  for (b=0;b<16;b++) ogl_camera[a].matrix[b]=0.0f;
  ogl_camera[a].matrix[0]=1.0f; ogl_camera[a].matrix[5]=1.0f;
  ogl_camera[a].matrix[10]=1.0f; ogl_camera[a].matrix[15]=1.0f;
  ogl_camera[a].posx=0.0f; ogl_camera[a].posy=0.0f; ogl_camera[a].posz=-15.0f;
  ogl_camera[a].angx=0.0f; ogl_camera[a].angy=0.0f; ogl_camera[a].angz=0.0f;
  ogl_camera[a].movx=0.0f; ogl_camera[a].movy=0.0f; ogl_camera[a].movz=0.0f;
  ogl_camera[a].rotx=0.0f; ogl_camera[a].roty=0.0f; ogl_camera[a].rotz=0.0f;
  ogl_camera[a].oldx=0.0f; ogl_camera[a].oldy=0.0f; ogl_camera[a].oldz=0.0f;
  ogl_camera[a].targetx=0.0f; ogl_camera[a].targety=0.0f; ogl_camera[a].targetz=0.0f;
  ogl_camera[a].speed=0.0f; ogl_camera[a].slide=0.0f;
  ogl_camera[a].falldwn=0.01f;
  ogl_camera[a].movetype=1;
  ogl_camera[a].viewdist=4096.0f;
  ogl_camera[a].FOV=60.0f;

  camera_update(a);
 }
 // nastavenie OpenGL renderovacich parametrov *****************************
 glClearColor(0.0f,0.0f,0.0f,0.5f); // zasobnik farieb bude vymazavany ciernou farbou
 glClearDepth(1.0f);                // zasobnik hlbky bude vymazavany nastavenim na 1.0
                                    // nastavenie parametrov 1 svetla
 glLightfv(GL_LIGHT0,GL_AMBIENT,ogl_light[0].amb);
 glLightfv(GL_LIGHT0,GL_DIFFUSE,ogl_light[0].dif);
 glLightfv(GL_LIGHT0,GL_SPECULAR,ogl_light[0].spe);
 ogl_lighting=0;                             // zapnutie/vypnutie osvetlenia
 if (ogl_lighting==1) glEnable(GL_LIGHTING); // zapnutie osvetlenia
 else glDisable(GL_LIGHTING);                // vypnutie osvetlenia
 glEnable(GL_LIGHT0);

 glDepthFunc(GL_LEQUAL);            // typ porovnavacej funkcie pre urcenie z-vzdialenosti
 glEnable(GL_DEPTH_TEST);           // zapnutie testovania hlbky

 glDisable(GL_CULL_FACE);           // nastavi poradie, v ktorom budu definovane body objektu
 glFrontFace(GL_CCW);               // reprezentovat privratene resp. odvratene plochy,
 glCullFace(GL_BACK);
 glEnable(GL_CULL_FACE);            // odvratene plochy sa nebudu spracovavat
                                    // vseobecny material objektov
 glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,ogl_light[0].spe);
                                    // svetelne vypocty su lokalne
 glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_TRUE);
 glShadeModel(GL_SMOOTH);           // zapne gourand-jemne tienovanie
                                    // osvetlenie textur alias modulate
 //glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
                                    // realnejsie perspektivne vypocty a korekcie
 glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);

 //glEnableClientState(GL_VERTEX_ARRAY);
 //glEnableClientState(GL_NORMAL_ARRAY);

 //glEnable(GL_LINE_SMOOTH);          // antialiasing ciar alias smoothline
 //glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);
                                    // funkcia pre vypocet priesvitnosti
 //glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
 //glEnable(GL_BLEND);              // zapnutie vypoctu priesvitnosti
 //glLineWidth(1.5);           

 //glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

 return 1;
}

// inicializacia kamery a OpenGL kresliacej plochy *************************
GLvoid COGL::camera_init(GLuint a,GLfloat w,GLfloat h)
{
 glMatrixMode(GL_PROJECTION); // vyber projekcnej matice
 glLoadIdentity();            // zresetovanie projekcnej matice

 if (h!=0) {                  // nastavenie perspektivneho premietania
  gluPerspective(ogl_camera[a].FOV,w/h,0.01f,ogl_camera[a].viewdist);
  glViewport(0,0,(GLint) w,(GLint) h);
 }
 else {
  gluPerspective(ogl_camera[a].FOV,w,0.01f,ogl_camera[a].viewdist);
  glViewport(0,0,(GLint) w,1);
 }

 // TRANSFORMUJEME SCENU NIE KAMERU!
 glMatrixMode(GL_MODELVIEW);  // vyber modelovej matice
 glLoadIdentity();            // zresetovanie modelovej matice
}

// aktualizacia nastaveni kamery *******************************************
GLvoid COGL::camera_update(GLuint a)
{
 ogl_camera[a].oldx=ogl_camera[a].posx; // ulozi staru poziciu
 ogl_camera[a].oldy=ogl_camera[a].posy;
 ogl_camera[a].oldz=ogl_camera[a].posz;

 // SPECIALNY PRISTUP K ROTACII A NASLEDNEMU POSUNU KAMERY!
 glMatrixMode(GL_MODELVIEW);
 glLoadMatrixf(ogl_camera[a].matrix);

 // ROTACIA
 glRotatef(ogl_camera[a].rotx,ogl_camera[a].matrix[0],
                              ogl_camera[a].matrix[4],
                              ogl_camera[a].matrix[8]);
 switch (ogl_camera[a].movetype) {
  case 0:                               // chodza
   glRotatef(ogl_camera[a].roty,0.0f,1.0f,0.0f);
   break;
  case 1:                               // let
   glRotatef(ogl_camera[a].roty,ogl_camera[a].matrix[1],
                                ogl_camera[a].matrix[5],
                                ogl_camera[a].matrix[9]);
   break;
  default:                              // dalsie typy pohybu...
   break;
 }
 glRotatef(ogl_camera[a].rotz,ogl_camera[a].matrix[2],
                              ogl_camera[a].matrix[6],
                              ogl_camera[a].matrix[10]);

 glGetFloatv(GL_MODELVIEW_MATRIX,ogl_camera[a].matrix);

 // POSUN
                                        // nastavenie novej pozicie
 ogl_camera[a].posx+=ogl_camera[a].matrix[0]*ogl_camera[a].movx+
                     ogl_camera[a].matrix[1]*ogl_camera[a].movy-
                     ogl_camera[a].matrix[2]*ogl_camera[a].movz;
 ogl_camera[a].posy+=ogl_camera[a].matrix[4]*ogl_camera[a].movx+
                     ogl_camera[a].matrix[5]*ogl_camera[a].movy-
                     ogl_camera[a].matrix[6]*ogl_camera[a].movz;
 ogl_camera[a].posz+=ogl_camera[a].matrix[8]*ogl_camera[a].movx+
                     ogl_camera[a].matrix[9]*ogl_camera[a].movy-
                     ogl_camera[a].matrix[10]*ogl_camera[a].movz;
                                        // nastavenie noveho natocenia
 ogl_camera[a].angx+=ogl_camera[a].rotx;
 ogl_camera[a].angy+=ogl_camera[a].roty;
 ogl_camera[a].angz+=ogl_camera[a].rotz;
                                        // nastavenie ciela kamery
 ogl_camera[a].targetx=ogl_camera[a].posx+ogl_camera[a].matrix[2];
 ogl_camera[a].targety=ogl_camera[a].posy+ogl_camera[a].matrix[6];
 ogl_camera[a].targetz=ogl_camera[a].posz+ogl_camera[a].matrix[10];
                                        // zrusenie dalsieho mozneho pohybu
 ogl_camera[a].movx=0.0f; ogl_camera[a].movy=0.0f; ogl_camera[a].movz=0.0f;
 ogl_camera[a].rotx=0.0f; ogl_camera[a].roty=0.0f; ogl_camera[a].rotz=0.0f;
}

// posun kamery ************************************************************
GLvoid COGL::camera_move(GLuint a)
{
 ogl_camera[a].movz=-ogl_camera[a].speed/40.0f;
 ogl_camera[a].movy=0.0f;
 ogl_camera[a].movx=-ogl_camera[a].slide/40.0f;
}

// natocenie kamery ********************************************************
GLvoid COGL::camera_rotate(GLuint a,GLfloat x,GLfloat y,GLfloat z)
{
 ogl_camera[a].rotx=x;
 ogl_camera[a].roty=y;
 ogl_camera[a].rotz=z;
}

// definicia objektov - suradnicova sustava ********************************
GLvoid COGL::obj_axis(GLfloat a)
{
 glBegin(GL_LINES);             // ciary
  glColor4f(a,0.0f,0.0f,1.0f);
  for (tx=0.0f;tx>-100.0f;tx-=10.0f) {
   glVertex3f(-50.0f,0.0f,tx);  // X
   glVertex3f(100.0f,0.0f,tx);
  }

  glColor4f(0.0f,a,0.0f,1.0f);
  for (tx=0.0f;tx>-100.0f;tx-=10.0f) {
   glVertex3f(0.0f,-50.0f,tx);  // Y
   glVertex3f(0.0f,100.0f,tx);
  }

  glColor4f(0.0f,0.0f,a,1.0f);
  for (tx=0.0f;tx<100.0f;tx+=10.0f) {
   glVertex3f(tx,0.0f,-100.0f); // Z
   glVertex3f(tx,0.0f,50.0f);
  }
 glEnd();
}

// definicia objektov - kocka biela ****************************************
GLvoid COGL::obj_cube0(GLfloat a)
{
 glBegin(GL_QUADS);               // kocka
  glColor4f(1.0f,1.0f,1.0f,1.0f); // farba

  glNormal3f(0.0f,0.0f,1.0f);
  glVertex3f(-a,-a,a);            // predna stena
  glVertex3f(a,-a,a);
  glVertex3f(a,a,a);
  glVertex3f(-a,a,a);

  glNormal3f(1.0f,0.0f,0.0f);
  glVertex3f(a,-a,a);             // prava stena
  glVertex3f(a,-a,-a);
  glVertex3f(a,a,-a);
  glVertex3f(a,a,a);

  glNormal3f(0.0f,0.0f,-1.0f);
  glVertex3f(a,-a,-a);            // zadna stena
  glVertex3f(-a,-a,-a);
  glVertex3f(-a,a,-a);
  glVertex3f(a,a,-a);

  glNormal3f(-1.0f,0.0f,0.0f);
  glVertex3f(-a,-a,-a);           // lava stena
  glVertex3f(-a,-a,a);
  glVertex3f(-a,a,a);
  glVertex3f(-a,a,-a);

  glNormal3f(0.0f,-1.0f,0.0f);
  glVertex3f(-a,-a,-a);           // dolna stena
  glVertex3f(a,-a,-a);
  glVertex3f(a,-a,a);
  glVertex3f(-a,-a,a);

  glNormal3f(0.0f,1.0f,0.0f);
  glVertex3f(-a,a,a);             // horna stena
  glVertex3f(a,a,a);
  glVertex3f(a,a,-a);
  glVertex3f(-a,a,-a);
 glEnd();
}

// definicia objektov - kocka farebna **************************************
GLvoid COGL::obj_cube1(GLfloat a)
{
 glBegin(GL_QUADS);               // kocka
  glNormal3f(0.0f,0.0f,1.0f);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(-a,-a,a);            // predna stena
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(a,-a,a);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(a,a,a);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(-a,a,a);

  glNormal3f(1.0f,0.0f,0.0f);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(a,-a,a);             // prava stena
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(a,-a,-a);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(a,a,-a);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(a,a,a);

  glNormal3f(0.0f,0.0f,-1.0f);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(a,-a,-a);            // zadna stena
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(-a,-a,-a);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(-a,a,-a);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(a,a,-a);

  glNormal3f(-1.0f,0.0f,0.0f);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(-a,-a,-a);           // lava stena
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(-a,-a,a);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(-a,a,a);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(-a,a,-a);

  glNormal3f(0.0f,-1.0f,0.0f);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(-a,-a,-a);           // dolna stena
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(a,-a,-a);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(a,-a,a);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(-a,-a,a);

  glNormal3f(0.0f,1.0f,0.0f);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(-a,a,a);             // horna stena
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(a,a,a);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(a,a,-a);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(-a,a,-a);
 glEnd();
}

